%%% Monte Carlo Dynamic Classifier tool - MCDC tool

% Copyright (C) 2014 Gareth W. Peters, Tomoko Matsui, Francois Septier, and Akira Tamamori

% This program is free software; you can redistribute it and/or modify it under the terms
% of the GNU General Public License as published by the Free Software Foundation; either
% version 2 of the License, or (at your option) any later version.

% This program is distributed in the hope that it will be useful, but WITHOUT ANY
% WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE.  See the GNU General Public License for more details.

% You should have received a copy of the GNU General Public License along with this
% program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
% Floor, Boston, MA 02110-1301 USA.

%
% GenericSpline.m
% 
% spapi を用いた、多次元対応 Spline 補間
%   xGrids: グリッドの次元毎の値の配列を、セル配列で与える
%   yArray: 各グリッド点における値を、多次元配列で与える
%   result: 補間された関数
%
function result = GenericSpline(xGrids, yArray)
  knots = num2cell(repmat(3, 1, length(xGrids))); % TODO knots
  if size(xGrids, 2) == 1
    y = yArray';
  else
    y = yArray;
  end
  sp = spapi(knots, xGrids, y);
  result = @(x) (fnval(sp, x));
end
