%%% Monte Carlo Dynamic Classifier tool - MCDC tool

% Copyright (C) 2014 Gareth W. Peters, Tomoko Matsui, Francois Septier, and Akira Tamamori

% This program is free software; you can redistribute it and/or modify it under the terms
% of the GNU General Public License as published by the Free Software Foundation; either
% version 2 of the License, or (at your option) any later version.

% This program is distributed in the hope that it will be useful, but WITHOUT ANY
% WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE.  See the GNU General Public License for more details.

% You should have received a copy of the GNU General Public License along with this
% program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
% Floor, Boston, MA 02110-1301 USA.

%
% MCDCStrategyChoice1_GPPF.m
%

classdef MCDCStrategyChoice1_GPPF < MCDCStrategy

  methods (Access = public)

    function this = MCDCStrategyChoice1_GPPF(algorithm)
      this = this@MCDCStrategy(algorithm)
      this.particleFilter = @ParticleFilter;
    end

    function result = StateMean(this, j, in, out)
      if j == 1
        gridPoints = this.gridData.GetFlatMatrix();
        dims = [size(in.stateMeanFuncs, 2) this.gridData.CountPerDim];
        this.initialStateMean = zeros(dims);
        for d = 1:dims(1)
          this.initialStateMean(d, :) = in.stateMeanFuncs{d}(gridPoints);
        end
      end
      result = this.initialStateMean;
    end

    function result = ObsMean(this, j, in, out)
      if j == 1
        gridPoints = this.gridData.GetFlatMatrix();
        dims = [size(in.obsMeanFuncs, 2) this.gridData.CountPerDim];
        this.initialObsMean = zeros(dims);
        for d = 1:dims(1)
          this.initialObsMean(d, :) = in.obsMeanFuncs{d}(gridPoints);
        end
      end
      result = this.initialObsMean;
    end

    function result = StateSigma(this, j, gramMatrix)
      result = gramMatrix;
    end

    function result = ObsSigma(this, j, gramMatrix)
      result = gramMatrix;
    end

    function result = AcceptanceLogProbability(this, j, in, out, logLikelihood, stateVals, obsVals, gramMatState, gramMatObs)
      result = 0;
    end

  end

end
