%%% Monte Carlo Dynamic Classifier tool - MCDC tool

% Copyright (C) 2014 Gareth W. Peters, Tomoko Matsui, Francois Septier, and Akira Tamamori

% This program is free software; you can redistribute it and/or modify it under the terms
% of the GNU General Public License as published by the Free Software Foundation; either
% version 2 of the License, or (at your option) any later version.

% This program is distributed in the hope that it will be useful, but WITHOUT ANY
% WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE.  See the GNU General Public License for more details.

% You should have received a copy of the GNU General Public License along with this
% program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
% Floor, Boston, MA 02110-1301 USA.

%
% RBFKernelGeneratorStrategyChoice2.m
%

classdef RBFKernelGeneratorStrategyChoice2 < RBFKernelGeneratorStrategy

  properties (Access = private)
    kind
  end

  methods (Access = public)

    function this = RBFKernelGeneratorStrategyChoice2(algorithm, kind)
      this = this@RBFKernelGeneratorStrategy(algorithm);
      this.kind = kind;
    end

    function result = GetGenerator(this, j, in, out)
      if j == 1
        result = this.initial;
      else
        dim = size(this.initial, 2);
        for i = 1:dim
          if this.kind == 1
            prevParams = out.SKPAt(j - 1);
          else
            prevParams = out.OKPAt(j - 1);
          end
          sDist = this.GetDistribution(prevParams(1, i, 1), 1, this.initial{i}.SDistribution);
          lDist = this.GetDistribution(prevParams(1, i, 2), 1, this.initial{i}.LDistribution);
          result{i} = RBFKernelGenerator(sDist, lDist);
        end
      end
    end

  end

  methods (Access = private)

    function result = GetDistribution(this, mu, sigma, uniformDist)
      result = BoundedNormalDistribution(mu, sigma, uniformDist.LowerBound, uniformDist.UpperBound);
    end

  end

end

