%%% Monte Carlo Dynamic Classifier tool - MCDC tool

% Copyright (C) 2014 Gareth W. Peters, Tomoko Matsui, Francois Septier, and Akira Tamamori

% This program is free software; you can redistribute it and/or modify it under the terms
% of the GNU General Public License as published by the Free Software Foundation; either
% version 2 of the License, or (at your option) any later version.

% This program is distributed in the hope that it will be useful, but WITHOUT ANY
% WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE.  See the GNU General Public License for more details.

% You should have received a copy of the GNU General Public License along with this
% program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
% Floor, Boston, MA 02110-1301 USA.

Times = 950:1000;

Iters = [1 10 100 1000 10000];
Iter = Iters(end);

load('logs/KitagawaModelPMMH2_Data.mat');

Graphs.YE('plots/KitagawaModelPMMH2_YE', ['logs/KitagawaModelPMMH2_' num2str(Iter) '.mat'], Iters);
Graphs.XE('plots/KitagawaModelPMMH2_XE', ['logs/KitagawaModelPMMH2_' num2str(Iter) '.mat'], Iters);
Graphs.YEMean('plots/KitagawaModelPMMH2_YEMean', ['logs/KitagawaModelPMMH2_' num2str(Iter) '.mat']);
Graphs.XEMean('plots/KitagawaModelPMMH2_XEMean', ['logs/KitagawaModelPMMH2_' num2str(Iter) '.mat']);

Graphs.YE(['plots/KitagawaModelPMMH2_YE_from' num2str(Times(1))], ['logs/KitagawaModelPMMH2_' num2str(Iter) '.mat'], Iters, Times);
Graphs.XE(['plots/KitagawaModelPMMH2_XE_from' num2str(Times(1))], ['logs/KitagawaModelPMMH2_' num2str(Iter) '.mat'], Iters, Times);
Graphs.YEMean(['plots/KitagawaModelPMMH2_YEMean_from' num2str(Times(1))], ['logs/KitagawaModelPMMH2_' num2str(Iter) '.mat'], Times);
Graphs.XEMean(['plots/KitagawaModelPMMH2_XEMean_from' num2str(Times(1))], ['logs/KitagawaModelPMMH2_' num2str(Iter) '.mat'], Times);

Graphs.Loglik('plots/KitagawaModelPMMH2_Loglik', ['logs/KitagawaModelPMMH2_' num2str(Iter) '.mat']);

quit;
