%%% Monte Carlo Dynamic Classifier tool - MCDC tool

% Copyright (C) 2014 Gareth W. Peters, Tomoko Matsui, Francois Septier, and Akira Tamamori

% This program is free software; you can redistribute it and/or modify it under the terms
% of the GNU General Public License as published by the Free Software Foundation; either
% version 2 of the License, or (at your option) any later version.

% This program is distributed in the hope that it will be useful, but WITHOUT ANY
% WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE.  See the GNU General Public License for more details.

% You should have received a copy of the GNU General Public License along with this
% program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
% Floor, Boston, MA 02110-1301 USA.

%
% LogMvnPdfTest.m
%

rng('shuffle');

dim = 10;

for n = 1:100
  x = rand(dim, 1)';
  mu = rand(dim, 1)';
  sigma = rand(dim);
  sigma = sigma * sigma';
  mineig = min(eig(sigma));
  if mineig < 0
    sigma = sigma - eye(dim) .* mineig;
  end
  result(1, n) = log(mvnpdf(x, mu, sigma));
  result(2, n) = LogMvnPdf(x, mu, sigma);
end

disp(result(1, :) - result(2, :));

