%%% Monte Carlo Dynamic Classifier tool - MCDC tool

% Copyright (C) 2014 Gareth W. Peters, Tomoko Matsui, Francois Septier, and Akira Tamamori

% This program is free software; you can redistribute it and/or modify it under the terms
% of the GNU General Public License as published by the Free Software Foundation; either
% version 2 of the License, or (at your option) any later version.

% This program is distributed in the hope that it will be useful, but WITHOUT ANY
% WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE.  See the GNU General Public License for more details.

% You should have received a copy of the GNU General Public License along with this
% program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
% Floor, Boston, MA 02110-1301 USA.

%
% VectorValuedFunctionTest.m
%

%
% Conversions from polar to X-Y, respectively.
%

functions{1} = @(v) v(1,:) .* cos(v(2,:));
functions{2} = @(v) v(1,:) .* sin(v(2,:));

polarToXY = VectorValuedFunction(functions);

%
% Testing.
%

radius   = linspace(0, 10, 100)';
angle    = linspace(0, 2 * pi(), 100)';
xyValues = polarToXY([radius angle]);

%
% Check the maximum error.
%

max(sqrt(sum((xyValues - [(radius .* cos(angle)) (radius .* sin(angle))]) .^ 2, 2)))

quit;

