%%% Monte Carlo Dynamic Classifier tool - MCDC tool

% Copyright (C) 2014 Gareth W. Peters, Tomoko Matsui, Francois Septier, and Akira Tamamori

% This program is free software; you can redistribute it and/or modify it under the terms
% of the GNU General Public License as published by the Free Software Foundation; either
% version 2 of the License, or (at your option) any later version.

% This program is distributed in the hope that it will be useful, but WITHOUT ANY
% WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE.  See the GNU General Public License for more details.

% You should have received a copy of the GNU General Public License along with this
% program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
% Floor, Boston, MA 02110-1301 USA.

%
% Spline.m
%

classdef Spline < handle

  methods(Static)

    function result = Cubic(x, y)
      f = spline(x, [0 y 0]);
      result = @(xx) (ppval(f, xx));
    end

    function result = B0(x, y)
      result = Spline.Bn(x, y, 0);
    end

    function result = B1(x, y)
      result = Spline.Bn(x, y, 1);
    end

    function result = B3(x, y)
      result = Spline.Bn(x, y, 3);
    end

    function result = Bn(x, y, d)
      l = length(x);
      f = spmak([repmat(x(1), 1, d) x repmat(x(l), 1, d + 1)], y);
      result = @(xx) (spval(f, xx));
    end

  end

end
